image: biophysics/gcc-gromacs

before_script:
  - mkdir -p ccache
  - export CCACHE_BASEDIR=${PWD}
  - export CCACHE_DIR=${PWD}/ccache

cache:
  key: ${CI_COMMIT_REF_SLUG}
  paths:
    - ccache/
    - build/CMakeCache.txt

build:
  stage: build
  tags:
    - k8s-scilifelab
  variables:
    KUBERNETES_CPU_LIMIT: 16
    KUBERNETES_MEMORY_LIMIT: 32Gi
    CACHE_FALLBACK_KEY: master
  script:
    - mkdir -p build
    - cd build
    - cmake -DCMAKE_C_COMPILER_LAUNCHER=ccache -DCMAKE_CXX_COMPILER_LAUNCHER=ccache .. && make -j 16 && make -j 16 tests
    - cd ..
    - tar czf gmx-build.tar.gz build/
  artifacts:
    paths:
      - gmx-build.tar.gz
      
test:
  stage: test
  tags:
    - k8s-scilifelab
  script:
    - tar xzf gmx-build.tar.gz
    - cd build
    - ctest -D ExperimentalTest
    - xsltproc scripts/CTest2JUnit.xsl Testing/`head -n 1 < Testing/TAG`/Test.xml > JUnitTestResults.xml
  artifacts:
    reports:
      junit: build/JUnitTestResults.xml
  artifacts:
      paths: 
          - build/JUnitTestResults.xml
      when: always
      expire_in: 1 week
